#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#define largo 1187
#define vez 200


int insert_hash (int *T,int k);
int search_hash(int *T, int k);
void conversion(int *B);

main()
{
    int B[largo], tabla[largo];

    float fc[61],intentos_prom[largo],promediobusq[largo];

    FILE *datosA,*datosB;
    printf("\n  *****************************************************\n");
    printf("  ** Programa de insercion y busqueda en tablas HASH **");
    printf("\n  *****************************************************\n");
    printf("\n  *****************************************************\n");
    printf("  **              Procesando datos......             **");
    printf("\n  *****************************************************\n");
    for(int j=0;j<largo;j++)
          {
          B[j]=0;                    // Este arreglo contendra los enteros representativos de las palabras.
          intentos_prom[j]=0.0;      // Este arreglo tendra los intentos promedio al insertar.
          promediobusq[j]=0.0;       // Este arreglo los promedio de busqueda
          }

    //  Llama a la funcin de que convierte las palabras del archivo words.txt
    //    a numeros generando el arrego que sera posteriormente a la tabla hash
   conversion(B);

//  la sentencia for es realizada 2 veces:
//            la primera utiliza una funcion de hash lineal


   for(int j, k=0, i; k<vez; k++)
      {
         for(int m=0;m<largo;m++)                                   // LLena la tabla hash con ceros:
             tabla[m]=0;

         j=5*k;
         i=0;
         int kk=1,gan=0,gan_busq=0;

         for( j;(j+i)<largo;i++)
           {
             gan=insert_hash(tabla,B[j+i]);  //insertar contenido en la tabla hash
             gan_busq +=search_hash(tabla,B[j+i]); //busqueda en la tabla hash   // debeereia ser equivalente a  gan_busq+=gan;

             if (i==(20*kk))
              {
                fc[kk-1]=1.0*(i)/largo ;
                intentos_prom[kk-1]+=(float)gan;    //guarda la cantidad de intentos promedio cada 20 inserciones
                promediobusq[kk-1]+=(float)gan_busq/(i);
                kk++;
              }
           }
         for(int n=0;n<j;n++)
           {
             gan=insert_hash(tabla,B[n]);  //insertar contenido en la tabla hash
             gan_busq +=search_hash(tabla,B[n]); //busqueda en la tabla hash   // debeereia ser equivalente a  gan_busq+=gan;

             if ((i+n)==(20*kk))
              {
                 fc[kk-1]=1.0*(i+n)/largo ;
                 intentos_prom[kk-1]+=(float)gan;    //guarda la cantidad de intentos promedio cada 20 inserciones
                 promediobusq[kk-1]+=(float)gan_busq/(i+n);
                 kk++;
              }
           }
      }
     printf("  ** Tabla Hash llenada, procesando ....los grficos **\n");
     printf("\n  *****************************************************\n");
     datosA= fopen("tablaA.dat", "w");
     datosB= fopen("tablaB.dat", "w");

     for(int i=0 ;i<59;i++)
       {
         fprintf(datosA,"\t%f\t%f\t%f\n",fc[i],intentos_prom[i]/vez,1/(1-fc[i]));
         fprintf(datosB,"\t%f\t%f\t%f\n",fc[i],promediobusq[i]/vez,1.0/fc[i]*log(1.0/(1-fc[i]))+1.0/fc[i]);
       }

     fclose(datosA);
     fclose(datosB);
     printf("  ** Programa de insercion y busqueda en tablas HASH **");
     printf("\n  *****************************************************\n");
     printf("  **              Generando grficos                 **");
     printf("\n  *****************************************************\n");
     printf("\n  *****************************************************\n");
     printf("  **        1: Grfico Insercion en la Tabla:        **\n");
     printf("  **           Presione ENTER para continuar         **");
     printf("\n  *****************************************************\n");
     system("gnuplot grapha.gnu");         //PLOTEO DE LOS ARCHIVOS CON LOS DATOS

     printf("\n  *****************************************************\n");
     printf("  **        2: Grfico Busqueda en la Tabla:         **\n");
     printf("  **           Presione ENTER para Finalizar         **");
     printf("\n  *****************************************************\n");
     system("gnuplot graphb.gnu");
     printf("\n  Trabajo realizado por Christian Pelissier y Claudio Ramirez \n");   
 }



